<template>
    <div id="main-center">
        <div id="main-top" class="car">
            <div id="main-header">
                <div id="main-header-left">
                    <div>Tour {{ currentTurn }}</div>
                    <div>00:00</div>
                </div>
                <div id="main-header-center">
                    <div id="guess-word">
                        <div v-if="roomState.isGameStarted && !currentUser.isUndercover && !currentUser.isMrWhite">{{ roomState.wordCivil }}</div>
                        <div v-else-if="roomState.isGameStarted && currentUser.isUndercover && !currentUser.isMrWhite">{{ roomState.wordUndercover }}</div>
                        <div v-else-if="roomState.isGameStarted && !currentUser.isUndercover && currentUser.isMrWhite">Bonne chance</div>
                        <div v-else>En attente ...</div>
                    </div>
                    <div v-if="roomState.isGameStarted && !currentUser.isUndercover && !currentUser.isMrWhite" id="role" class="civil">CIVIL</div>
                    <div v-else-if="roomState.isGameStarted && currentUser.isUndercover && !currentUser.isMrWhite" id="role" class="undercover">UNDERCOVER</div>
                    <div v-else-if="roomState.isGameStarted && !currentUser.isUndercover && currentUser.isMrWhite" id="role" class="mrWhite">MR.WHITE</div>
                </div>
                <div id="main-header-right">
                    <div id="mrWhiteLeft">
                        <img src="@/assets/images/form/white.svg" alt="">
                        <div id="countMrWhite">{{ roomState.countMrWhite }}</div>
                    </div>
                    <div id="undercoverLeft">
                        <img src="@/assets/images/form/undercover.svg" alt="">
                        <div id="countMrWhite">{{ roomState.countUndercover }}</div>
                    </div>
                </div>
            </div>
            <div id="characters">
                <UserProfile v-for="user in users" :key="user" :username="user.username" :skin="user.skin"/>
            </div>
        </div>
        <div id="main-bottom">
            <div v-if="roomState.isGameStarted || currentUser.id != roomState.roomOwner" id="input-text" class="show-input-text">
                <input id="input-word"
                :disabled="!(roomState.isGameStarted && (roomState.currentUser.id === nextUserToPlay.id))"
                :placeholder="roomState.isGameStarted ? 'C\'est au tour de : ' : 'En attente ...'"
                type="text"
                autocomplete="off">
                <label for="input-word"></label>
                <Timer @sendInputWordFromChild="sendInputWord"/>
            </div>
            <div v-if="!roomState.isGameStarted && currentUser.id == roomState.roomOwner" @click="startGame" id="action" class="show-owner-btn">
                <button id="action-btn">Lancer la partie</button>
            </div>
        </div>
    </div>
</template>

<script>
import UserProfile from '../components/room/UserProfile'
import Timer from '../components/room/Timer'
import { io } from 'socket.io-client';
import {
    mapActions, mapGetters
} from 'vuex'


export default {
    components: {
        UserProfile,
        Timer
    },
    methods: {
        ...mapActions([
            'editMenu',
            'removeUser',
            'setUsers',
            'setCurrentUser',
            'addLocalStorageIdToUser',
            'setIsGameStarted',
            'setCurrentSkin',
            'setRoomOwner',
            'setNbUndercover',
            'setNbMrWhite',
            'setWordCivil',
            'setWordUndercover',
            'setNextUserToPlay',
            'setTimerIsStarted'
        ]),
        startGame() {
            this.socket.emit('startGame', { idRoom: this.$route.params.id })
        },
        sendInputWord: function() {
            if (this.currentUser.id == this.nextUserToPlay.id)
                console.log('im here')
        }
    },
    created() {
        this.socket = io(process.env.VUE_APP_API_URL);
    },
    computed: {
        ...mapGetters([
            'getRoomState',
            'getCurrentUser',
            'getUsersInRoom',
            'getCurrentSkin',
            'getNextUserToPlay'
        ]),
        roomState() {
            return this.getRoomState;
        },
        users() {
            return this.getUsersInRoom;
        },
        currentUser() {
            return this.getCurrentUser;
        },
        currentTurn() {
            return this.getRoomState.currentTurn;
        },
        nextUserToPlay() {
            return this.getNextUserToPlay
        }
    },
    mounted() {
        this.editMenu(false)

        const idLocalStorage = localStorage.getItem('id') ? localStorage.getItem('id') : ''
        if (idLocalStorage) {
            this.addLocalStorageIdToUser(idLocalStorage)
        } else if (!this.currentUser.username) {
            return this.$router.push({ name: 'join', params: { id: this.$route.params.id } })
        }

        this.socket.emit('setup', { idRoom: this.$route.params.id, user: this.currentUser })

        this.socket.on('setupRoom', room => {
            this.setRoomOwner(room.roomOwner)
            this.setNbUndercover(room.countUndercover)
            this.setNbMrWhite(room.countMrWhite)
        })

        this.socket.on('setup', user => {
            this.setCurrentUser(user)
            this.setCurrentSkin({ name: user.skin })
            localStorage.setItem('id', user.id)
        })

        this.socket.on('remove-user', data => this.removeUser(data))

        this.socket.on('users', users => {
            this.setUsers(users)
        })

        this.socket.on('game-started', data => {
            this.setIsGameStarted(true)
            this.setUsers(data.users)
            const currentUser = data.users.find(user => user.id == this.currentUser.id)
            this.setCurrentUser(currentUser)
            this.setWordCivil(data.synoword.civilWord)
            this.setWordUndercover(data.synoword.undercoverWord)
        })
    
        this.socket.on('nextUserToPlay', user => {
            this.setNextUserToPlay(user)
            this.setTimerIsStarted(true)
        })

    },
    beforeCreate: function() {
        document.body.style.background = '#0a0717';
    }
}
</script>

<style scoped>
    *, ::after, ::before {
        box-sizing: border-box;
    }

    html, body {
        width: 100vw;
        height: 100vh;
        margin: 0;
        font-family: 'Roboto', sans-serif !important;
        overflow: hidden;
        color: white;
        line-height: 1.5;
    }

    #main-center {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 80vw;
        height: 90vh;
    }

    #main-top {
        position: relative;
        height: 80%;
        display: flex;
        flex-direction: column;
        justify-content: space-between;
    }

    #main-top.rain {
        box-shadow: inset 00px -10px 100px 100px #0a0717;
        background: radial-gradient(
                circle,
                rgba(10, 7, 23, 0.12648809523809523) 0%,
                rgba(10, 7, 23, 0.4906337535014006) 31%,
                rgba(10, 7, 23, 1) 78%),
        url('https://puu.sh/GKPEg/dad8e6a5c6.gif') no-repeat;
        background-size: cover;
        background-position: center;
    }

    #main-top.car {
        box-shadow: inset 00px -10px 100px 100px #0a0717;
        background: radial-gradient(
                circle,
                rgba(10, 7, 23, 0.12648809523809523) 0%,
                rgba(10, 7, 23, 0.4906337535014006) 31%,
                rgba(10, 7, 23, 1) 78%),
        url('https://cdn.discordapp.com/attachments/293803324875079680/774670872920981544/easyloader-min.png') no-repeat;
        background-size: cover;
        background-position: center;
    }

    #main-header {
        display: flex;
        justify-content: space-between;
        padding: 0 150px;
        align-items: center;
        height: 97px;
    }

    #main-header-left {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        text-transform: uppercase;
        font-weight: bold;
        color: white;
    }

    #main-header-left div:nth-child(2) {
        font-size: 30px;
    }

    #main-header-center {
        position: absolute;
        top: 0;
        left: 50%;
        transform: translateX(-50%);
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;
        color: white;
        font-weight: bold;
        text-transform: uppercase;
    }

    #main-header-right {
        display: flex;
        flex-direction: row;
        justify-content: center;
        align-items: center;
        flex: 0 0 100px;
        font-weight: bold;
    }

    #main-header-right img {
        width: 40px;
        margin-right: 5px;
    }

    #mrWhiteLeft {
        display: flex;
        align-items: center;
        justify-content: center;
        margin-right: 17px;
        color: white;
    }

    #undercoverLeft {
        display: flex;
        align-items: center;
        justify-content: center;
        color: white;
    }


    #guess-word {
        padding: 6px 50px;
        background: #191139;
        color: white;
        font-size: 30px;
        border-radius: 15px;
        min-width: 230px;
        text-align: center;
        text-transform: uppercase;
        font-weight: bold;
        letter-spacing: 1.5px;
        position: relative;
        z-index: 1;
        box-shadow: 0 15px 10px -15px black;
    }

    #role {
        padding: 8px 40px 5px 40px;
        color: white;
        font-size: 18px;
        border-radius: 0 0 8px 8px;
        text-transform: uppercase;
        font-weight: bold;
        letter-spacing: 1.5px;
        display: block;
    }

    #role.undercover {
        background: #51000B;
        color: white;
    }

    #role.mrWhite {
        background: #cccccc;
        color: #191625;
    }

    #role.civil {
        background: #26538C;
        color: white;
    }

    #characters {
        width: 100%;
        display: flex;
        justify-content: space-around;
        align-items: center;
    }

    #main-bottom {
        display: flex;
        justify-content: center;
        align-items: center;
        height: 20%;
    }

    #input-text {
        display: flex;
        flex-direction: column;
        align-items: center;
    }

    #input-word {
        padding: 10px 50px;
        background: white;
        color: black;
        font-size: 20px;
        border-radius: 10px 10px 0 0;
        text-transform: uppercase;
        border: none;
        text-align: center;
        font-weight: bold;
        outline: none;
        font-family: inherit;
        line-height: inherit;
    }

    #input-word::placeholder {
        font-size: 13px;
        text-transform: uppercase;
        color: #5d5d5d;
        text-align: center;
        font-weight: bold;
    }

    #action {
        display: flex;
        flex-direction: column;
        align-items: center;
    }

    #action-btn {
        padding: 10px 50px;
        background: white;
        color: #0a0717;
        font-size: 20px;
        border-radius: 10px;
        text-transform: uppercase;
        border: none;
        text-align: center;
        font-weight: bold;
        outline: none;
        cursor: pointer;
        font-family: inherit;
        line-height: inherit;
    }

    #action-btn:hover {
        transition: all 0.2s;
        color: #573dbd;
    }
</style>